<% @Page Language="VB" Explicit="True" %>
<script runat=server>
    Public hs As Scheduler.hsapplication

    Public cyclesFound As Integer
    Dim progAry(25, 9) As String  '25 lines, 9 params per line to hold cycles
    Dim runvals(8) As Integer  'this holds the values that are being run
    Dim tparams() As String   'use this for temporary splits
    Dim cAry() As String            'array to hold controller data
    Dim runmode As Boolean      'true if a runcycle post variable was provided
    Dim errmode As Boolean          'true if no controller data received
    Dim rstr As String
    Public zones As Integer
    Dim tstr, tempstr As String
    Dim controllerstr As String
    Dim respStr As String
    Public i As Integer
    Public cyndx As Integer


    Function readCycles() As Integer
        'this vbscript function is executed on the server
        'we cant read or write files to the server using vbscript
        'we don't want to use hs global variables because they are destroyed at reboot
        'we will use the hs.getINISection and hs.saveINISetting functions get and save the cycles
        'use the following  command to save the cycles:  (creates section "stored cycles" and key "ercycles"
        '       hs.SaveINISetting "stored cycles","ercycles",erVar,"EtherRain.ini"
	
        Dim i, j As Integer
        ' Dim wstr, kstr As String
        Dim erVar As String
        Dim cycles() As String   'this is a one dimensional array
        Dim params() As String   'this is a one dimensional array
        'Dim estr As String
        Dim items() As String
        Dim section As String
	
        erVar = ""
        section = hs.GetINISection("stored cycles", "EtherRain.ini")
        If Len(section) > 0 Then
            items = Split(section, Chr(0))
            For i = 0 To UBound(items)
                'Response.Write "<p><b>Item " & items(i) & "</b></p><hr>"
                j = InStr(items(i), "ercycles=")
                If j > 0 Then
                    erVar = Mid(items(i), j + 9)
                    Exit For
                End If
            Next
        End If
        'Response.Write "<p><b>ER Var length is : " & len(erVar) & "bytes)</b></p><hr>"
        'Response.Write "<p><b>ER Var is : " & erVar & "</b></p><hr>"
	
        readCycles = 0
        If Len(erVar) = 0 Then
            'now initialize the empty array
            For i = 0 To 24
                For j = 0 To 8
                    progAry(i, j) = ""
                Next
            Next
        Else  'parse the storage variable here
            'the cycles are separated by "|" 
            'the values are separated by ";"
            'we need to utilize the split function twice to load progAry
            cycles = Split(erVar, "|")
            If IsArray(cycles) = True Then readCycles = UBound(cycles) + 1
            For i = 0 To UBound(cycles)
                params = Split(cycles(i), ";")
                For j = 0 To UBound(params)
                    progAry(i, j) = params(j)
                Next
            Next
        End If
            '8-31-2009 if no cycles you get an error; below fixes
    End Function

    '    ***End Function Declaration***
    
</script>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<HEAD runat=server >
<% Response.Write(vbNewLine)%>
<title>EtherRain Run Quick Cycle for HS3</title>
<% Response.Write(vbNewLine)%>
<link rel="stylesheet" type="text/css" href="/style.css"/>
<% Response.Write(vbNewLine)%>

<%
    '    **** main script block  *****
    'this line must be on every page along with the original dim
    hs = Context.Items("Content")
    
    Dim i As Integer
    Dim qparstr As String
    
    
    'if runmode is false, means we setting up the cycle
    errmode = False
    runmode = False
    cyclesFound = 0
    cyndx = 0  'this is the index of the selected cycle; zero upon entry; but set upon re-entry

    'first and always set up the quickcycle lists and controls
    rstr = Request.Form("controller")   'this is set on reference from er_home.aspx and upon re-entry
    'Response.Write("<p><b>controller info: " & rstr & "</b></p><hr>")
    If Len(rstr) > 0 Then
        cyclesFound = readCycles()
        controllerstr = rstr  'save the whole controller string for re-entry use
        'rstr is in form: controller name; controllerpw; zn1;zn2;zn3;zn4;zn5;zn6;zn7;zn8
        cAry = Split(rstr, ";")
        'Response.Write("<p><b>cAry info: " & cAry(0) & " " & cAry(1) & " " & cAry(2) & " " & cAry(3) & " ubound cAry: " & UBound(cAry) & " </b></p><hr>")
        zones = 0
        'to get zones, need to find the first cAry() having empty string
        For i = 2 To UBound(cAry)
            If Len(cAry(i)) > 0 Then
                zones = zones + 1
            Else
                Exit For
            End If
        Next
        'check to see if cyndx has been posted through a re-enter;this will initialize the zone box
        tempstr = Request.Form("cyclendx")
        'Response.Write("<p><b>cyclendx is: " & tempstr & "</b></p><hr>")
        If Len(tempstr) > 0 Then
            cyndx = CInt(tempstr)
        End If
    Else
        errmode = True      'display error message, no controller defined
        zones = 0
    End If
    'now if we've received a runcycle post, then we need to run the cycle
    tempstr = Request.Form("runcycle")
    If Len(tempstr) > 0 Then
        runmode = True       'this lets us post results instead of intro paragraph
        'make sure to re-enter the zone entries
        For i = 0 To 7
            runvals(i) = "0"
        Next
        tparams = Split(tempstr, ";")
        For i = 0 To UBound(tparams)
            runvals(i) = tparams(i)
        Next
        'the user could have selected a cycle and changed some times
        'copy the runvalues into the runvals array
        'the posted variable contains the values
        'the controller name and password should be:  cAry(0) cAry(1)
        'the runcycle post variable should only contain the zone times z1;z2;z3; ... z8
        'qparstr = controller name, controller password, zone values
        qparstr = Trim(cAry(0)) & ";" & Trim(cAry(1)) & ";"
        For i = 0 To 7
            qparstr = qparstr & runvals(i)
            If i < 7 Then qparstr = qparstr & ";"
        Next
        ' example:     Garden-Test; pw; 0;0;1;1;0;0;0;0
        'Response.Write("<p><b>qparstr is: " & qparstr & "</b></p><hr>")
        'Response.Write(vbNewLine)
        respStr = hs.RunScriptFunc("EtherRain.vb", "runCycleRet", qparstr, True, False)
        'Response.Write "<p><b>response is: " & res & "</b></p><hr>"
    End If

%>

<script type="text/javascript">
 <!--

  //load in the cycle data to js
  	<% Response.Write("var zz = " & zones & ";") %>
      var zt = new Array(); 
		//now setup javascript time parameters
	<%
        for i = 0 to cyclesFound-1 
		  tstr = "zt[" & i & "]= new Array("
		  for  j = 0 to zones-1
		     tstr = tstr & """" & progAry(i,j+1) & """"
			 if  j < zones-1 then 
			    tstr = tstr & ","
			 else 
			    tstr = tstr & " );" & vbcrlf
		     end if
	      next
		  Response.Write( tstr)
		next
	%>	

  function updateCyMins(ndx)
	{
        var j = ndx;
		var i;
		var tstr;

		tstr = cycleselect.options[j].text;
		for (i=0;i < zz;i++) {
		  tstr = "z" + (i);
 		  cycleform[tstr].value = zt[j][i];
	    }
	   //update the selected index for any re-entry
	   document.cycleform.cyclendx.value = ndx;
	} 
   function checkMakeVars ( form )
	{
        var tstr = "";
		var i;
		var j;
		var k = 0;
		var wstr = "";
		var nstr = "";
		
       //now put all the data into one string
	    wstr = "" ;
		//alert(wstr);
		for (i=0;i < zz; i++) {
		  tstr = "z" + (i);
 		  wstr = wstr + cycleform[tstr].value ;
		  if ( i < zz-1) {
		     wstr = wstr + ";";
		  }
	    }
	    form.runcycle.value = wstr;
		//alert(wstr);
		//return false;
        return true;
	}
	 
    //-->
</script> 

</head>
<body style= "margin-left: 4%; margin-right: 4%; background:white; 
			 color: black; 
			 font-size: 11px;
			 font-weight: normal;
			 font-family: verdana, arial, sans-serif;"
>

	  <div style="float:left; width:800px; height:26px;padding-top:3px;padding-left:2px; background-color: black;border-bottom:solid 2px grey;">
	   
	  <input style="width:120px;" type="button" class="linkrowbutton" value="HomeSeer Start" alt="Start" onClick="location.href='/start/start.aspx'" onmouseover="this.className='linkrowbuttonselected';" onmouseout="this.className='linkrowbutton';">
	  <input style="width:120px;" type="button" class="linkrowbutton" value="HomeSeer Home" alt="Home" onClick="location.href='/'" onmouseover="this.className='linkrowbuttonselected';" onmouseout="this.className='linkrowbutton';">
	  <input style="width:120px;" type="button" class="linkrowbutton" value="EtherRain Home" alt="EtherRain Home" onClick="location.href='er_home.aspx'" onmouseover="this.className='linkrowbuttonselected';" onmouseout="this.className='linkrowbutton';">
	  <input style="width:120px;" type="button" class="linkrowbutton" value="EtherRain Help" alt="EtherRain Help" onClick="location.href='er_help.aspx'" onmouseover="this.className='linkrowbuttonselected';" onmouseout="this.className='linkrowbutton';">
	  </div>

    <div style="float:left; width:800px; text-align: center;
			font-size: 11px; font-weight: normal;
	         text-align:center;   /* hack for ie5  */
			font-family: verdana, arial, sans-serif; ">
   

    <div style="float:left; width: 800px;height:60px; 
		        border: 1px solid forestgreen;
			    background-color: lightgreen;
				font:arial, sans-serif; ">
		 <div style="float:left; width: 80px;margin-top:6px;">
	         <img style= "float:left; padding-left:35px;" align="middle" alt="EtherRain Logo" src="ershieldlogo.png" />  
	     </div>
		 <div style= "float:left;width: 610px;padding-top:7px;">
              <p style="color:white;font-weight:600; font-size:24px;
			            margin-top:5px; margin-bottom:2px;padding-top:5px;text-align:center;">
		             EtherRain Run Quick Cycle
			  </p>
		 </div>
    </div>

    <div style="float:left; width:800px;height:520px;margin-top:2px;border:1px solid silver;
		text-align:left; overflow: auto;">
        <div style="float:left; width:70px; height:510px; margin:0px; ">
        </div>
        <div style="float:left; width:660px; height:515px; margin:0px; ">
	    <%
	        Dim i As Integer
	        
	        If runmode = False Then
	            Response.Write("<p style=""padding-left:40px; padding-right:30px; margin-top:8px;margin-bottom:8px;text-align:justify;"">")
	            Response.Write("To run a quick cycle (also called a manual cycle) select a pre-defined cycle from ")
	            Response.Write("the list box or enter time values in the zone fields provided.  Then click the ")
	            Response.Write("Run button. ")
	            Response.Write("</p>")
	            Response.Write("<p style=""padding-left:40px; padding-right:30px; margin-top:8px;margin-bottom:25px;text-align:justify;"">")
	            Response.Write("This Quick Cycle service does not apply any setback information, the time values displayed ")
	            Response.Write("in the zone time fields will be used in the cycle.  ")
	            Response.Write("</p>")
	            Response.Write("<p style=""padding-left:40px; padding-right:30px; margin-top:8px;margin-bottom:10px;color:steelblue; font-size:12px; font-weight:bold; text-align:center;"">")
	        Else
	            'show the results of the run
	            Response.Write("<div style=""float:left;margin-left:50px; width:500px;height:80px;")
	            Response.Write("margin-top:20px;margin-bottom:20px;border:1px solid steelblue;text-align:left;"">")
	            Response.Write("<p style=""padding-left:40px; padding-right:30px; margin-top:10px;")
	            Response.Write("margin-bottom: 8px;font-weight:bold; font-size:12px; color:steelblue; text-align:center;"">")
	            Response.Write("QuickCycle Results")
	            Response.Write("</p>")
	            If InStr(respStr, "Irrigation CMD Delivered") > 0 Then
	                Response.Write("<p style=""padding-left:40px; padding-right:30px; margin-top:15px;margin-bottom: 8px;text-align:center;"">")
	            Else
	                Response.Write("<p style=""padding-left:40px; padding-right:30px; margin-top:15px;margin-bottom: 8px;color:red;text-align:center;"">")
	            End If
	            Response.Write(respStr)
	            Response.Write("</p>")
	            Response.Write("</div>")
	            Response.Write("<br style=""clear:both;"">")
	        End If
		
		
	        If errmode = False Then
	            Response.Write("<p style=""padding-left:40px; padding-right:30px; margin-top:8px;margin-bottom:10px;color:steelblue; font-size:12px; font-weight:bold; text-align:center;"">")
	            Response.Write("Using Controller: " & cAry(0))
	        Else
	            Response.Write("<p style=""padding-left:40px; padding-right:30px; margin-top:8px;margin-bottom:10px;color:red; font-size:12px;  text-align:center;"">")
	            Response.Write("Controller information not provided. Can't run Quick Cycle.")
	        End If
	        Response.Write("</p>")
	
	        If errmode = False Then
	            Response.Write("<div style=""float:left; width:230px;height:300px;margin-top:15px;margin-left:14px;")
	            Response.Write("	text-align:left; overflow: auto;"">")
	            Response.Write("<p style=""padding-left:20px; padding-right:20px; margin-top:5px;margin-bottom:8px;color:steelblue; font-size:12px;font-weight:bold;  text-align:center;"">")
	            Response.Write("Defined Cycles")
	            Response.Write("</p>")
	            Response.Write("<p style=""padding-left:20px; padding-right:20px; margin-top:8px;margin-bottom:10px;color:red; font-size:12px;  text-align:center;"">")

	            If cyclesFound > 0 Then
	                Response.Write("<select style=""width:150px;"" name=""cycleselect"" id=""sel1"" size=""10"" onchange=""updateCyMins(this.options[this.selectedIndex].value);"">")
	                For i = 0 To cyclesFound - 1
	                    If i = cyndx Then
	                        Response.Write("<option value=""" & i & """ selected>" & progAry(i, 0) & "</option>")
	                    Else
	                        Response.Write("<option value=""" & i & """>" & progAry(i, 0) & "</option>")
	                    End If
	                Next
	                Response.Write("</select>")
	            Else
	                Response.Write("<select style=""width:150px;"" name=""cycleselect"" id=""sel1"" size=""10"" >")
	                Response.Write("</select>")
	            End If
	            Response.Write("</p>")
	            Response.Write("<p style=""padding-left:20px; padding-right:20px; margin-top:5px;margin-bottom:10px;color:darkgrey; font-size:10px;  text-align:center;"">")
	            Response.Write("(Use CycleBuilder to define cycles).")
	            Response.Write("</p>")
	            Response.Write("</div>")
	            Response.Write("<div style=""float:left; width:340px;height:330px;margin-top:15px;text-align:left; overflow: auto;"">")
	            Response.Write("<form name=""cycleform"" action=""er_quickcycle.aspx"" method=""post"" onsubmit=""return checkMakeVars(this);"">")
	            Response.Write("<table style=""text-align: center;font-family: Verdana, sans-serif, Arial;")
	            Response.Write("font-weight: normal;color: #404040;width: 260px;background-color: #fafafa;")
	            Response.Write("border: 1px #d79900 solid;border-collapse: collapse;border-spacing: 0px;""")
	            Response.Write("cellspacing=""0"" cellpadding=""3"" align=""center"" border=""0"">")
	            Response.Write("<thead bgcolor=whitesmoke >")
	            Response.Write("<tr style= ""background-color: #fff2ba;"">")
	            Response.Write("<th  style=""font-size: 12px;font-weight: bold;color:peru; border: 1px #d79900 solid;"" >Zone</th>")
	            Response.Write("<th style=""font-size: 12px;font-weight: bold;color:peru; border-bottom: 1px #d79900 solid;"">Minutes</th>")
	            Response.Write("</tr>")
   		  
	            Response.Write("</thead>")
	            Response.Write("<tbody >")
				 
	            For i = 0 To zones - 1
	                Response.Write("<tr style=""border-bottom: 1px dotted #d79900;text-align: left; font-family: Verdana; font-weight: 400;color: #404040;"">")
	                Response.Write("<td style=""padding-left:15px; text-align:left;width:170px;font-size:12px;"">" & cAry(i + 2) & ":</td>")
	                Response.Write("<td style=""text-align:center;font-size:11px;padding-left:10px;"">")
	                If runmode = True Then
	                    Response.Write("<INPUT style=""width:18px;font-size:12px;"" TYPE=""text"" NAME=""z" & i & """ value = """ & runvals(i) & """ maxlength=""2"" SIZE=""3"">")
	                Else
	                    Response.Write("<INPUT style=""width:18px;font-size:12px;"" TYPE=""text"" NAME=""z" & i & """ value = """ & progAry(cyndx, i + 1) & """ maxlength=""2"" SIZE=""3"">")
	                End If
	                Response.Write("</td>")
	                Response.Write("</tr>")
				   
	            Next
				   
				  

	            Response.Write("</tbody>")
	            Response.Write("</table>")
	            Response.Write("<INPUT TYPE=""hidden"" NAME = ""postcheck"" VALUE=""1"" />")
	            Response.Write("<INPUT TYPE=""hidden"" NAME = ""controller"" VALUE=""" & controllerstr & """ />")
	            Response.Write("<INPUT TYPE=""hidden"" NAME = ""runcycle"" VALUE="""" />")
	            Response.Write("<INPUT TYPE=""hidden"" NAME = ""cyclendx"" VALUE=""0"" />")
	            Response.Write("<p style=""font-size:14px;margin-top:10px; margin-bottom:10px;padding-left: 45px; text-align:center; font:arial; "">")
	            Response.Write("<input type=""submit"" value=""Run Cycle"" /> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;")
	            Response.Write("</p>")
	            Response.Write("</form>")
	            Response.Write("</div>")
	        End If
		 
         %>
	    </div>
	   
	</div>
     <p style="padding-left:10px;  font-size:10px; text-align:left; ">
         &copy; 2011-2014 by QuickSmart Development www.quicksmart.com
      </p>
   </div>

 </body>
</html>
